Bug 84843 - Disable all Drawing toolbar buttons in read-only mode
Summary: Disable all Drawing toolbar buttons in read-only mode
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: UI (show other bugs)
Version:
(earliest affected)
Inherited From OOo
Hardware: Other All
: medium normal
Assignee: Maxim Monastirsky
URL:
Whiteboard: target:5.2.0
Keywords:
Depends on:
Blocks:
 
Reported: 2014-10-09 14:51 UTC by Jacobo Aragunde Pérez
Modified: 2016-10-25 19:11 UTC (History)
4 users (show)

See Also:
Crash report or crash signature:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Jacobo Aragunde Pérez 2014-10-09 14:51:07 UTC
If you enable read-only mode by opening a read-only file or toggling the "edit file" button in the toolbar and you had the drawing toolbar enabled, you cannot press the "show draw functions" to hide it because the button is disabled.

Besides, not all buttons in the drawing toolbar get disabled while in read-only mode (e.g. drawing lines and rectangles), but the buttons have no effect.

All in all, I think the drawing toolbar should be hidden while in read-only mode, just like the formatting toolbar is.
Comment 1 Yousuf Philips (jay) (retired) 2014-10-09 15:24:42 UTC
Hi Jacobo,

This only seems to effect Writer as it doesnt effect Drawing. The buttons which are still active are line, rectangle, ellipse, freeform, textbox, vertical textbox, callouts, and vertical callouts. This effects 4.3.3 and master.

Version: 4.3.3.0.0+
Build ID: 18b9cb260a5ec358f6a7b73362bbc306af0417b1
TinderBox: Linux-rpm_deb-x86@45-TDF, Branch:libreoffice-4-3, Time: 2014-10-04_04:41:44

Version: 4.4.0.0.alpha0+
Build ID: ced24ffba2fa1754c466b7944b0ee06d21292706
TinderBox: Linux-rpm_deb-x86@45-TDF, Branch:master, Time: 2014-10-04_21:36:54
Comment 2 QA Administrators 2015-10-14 19:57:43 UTC Comment hidden (obsolete)
Comment 3 Jacobo Aragunde Pérez 2015-10-30 08:53:51 UTC
Still reproducible in master. Easy steps:

1. Open any Writer document.
2. Enable the drawing toolbar.
3. Press Shift+Ctrl+M to toggle edit mode.

Result: drawing toolbar still visible, some buttons enabled but have no effect.

Expected result: drawing toolbar should disappear just like the formatting toolbar.


Version: 5.1.0.0.alpha1+
Build ID: 086aec27ddfd72dc21fffb0466cb5c815e2b4169
Comment 4 Yousuf Philips (jay) (retired) 2015-10-30 23:42:03 UTC
Hi Jacobo,

Seems i was mistaken as the Drawing toolbar doesnt hide in any module once edit mode is activated, but in Impress/Draw, all the buttons are disabled, which doesnt happen in Writer or Calc, so lets unify this behaviour.

UNO Commands that are currently active - .uno:Line, .uno:Freeline_Unfilled, .uno:Bezier_Unfilled, .uno:Polygon_Unfilled, .uno:Arc, .uno:Pie, .uno:CircleCut, .uno:DrawCaption, .uno:VerticalCaption, .uno:DrawText, .uno:VerticalText, .uno:Text_Marquee
Comment 5 Maxim Monastirsky 2015-11-04 14:24:33 UTC
(In reply to Yousuf (Jay) Philips from comment #4)
> UNO Commands that are currently active - .uno:Line, .uno:Freeline_Unfilled,
> .uno:Bezier_Unfilled, .uno:Polygon_Unfilled, .uno:Arc, .uno:Pie,
> .uno:CircleCut, .uno:DrawCaption, .uno:VerticalCaption, .uno:DrawText,
> .uno:VerticalText, .uno:Text_Marquee
In other words: Everything that is PseudoSlot of SID_INSERT_DRAW. I wonder whether this PseudoSlot thing is still useful today for something, or it can be finally killed?

One weird thing I noticed, is that the same .uno:Line is disabled in the menubar (in Insert->Shapes). Also if you hide the toolbar and show again, they all will be disabled there. But if you then click somewhere in the document, they will be enabled again.
Comment 6 Yousuf Philips (jay) (retired) 2015-11-26 14:09:49 UTC
(In reply to Maxim Monastirsky from comment #5)
> I wonder
> whether this PseudoSlot thing is still useful today for something, or it can
> be finally killed?

Dont understand what PseudoSlot is and wondered if you were posing this question to me.

> One weird thing I noticed, is that the same .uno:Line is disabled in the
> menubar (in Insert->Shapes).

Interesting

> Also if you hide the toolbar and show again,
> they all will be disabled there. But if you then click somewhere in the
> document, they will be enabled again.

I had noticed this behaviour.
Comment 7 Robinson Tryon (qubit) 2015-12-13 11:24:03 UTC Comment hidden (obsolete)
Comment 8 Maxim Monastirsky 2016-01-31 22:59:26 UTC
(In reply to Yousuf (Jay) Philips from comment #4)
> UNO Commands that are currently active - .uno:Line, .uno:Freeline_Unfilled,
> .uno:Bezier_Unfilled, .uno:Polygon_Unfilled, .uno:Arc, .uno:Pie,
> .uno:CircleCut, .uno:DrawCaption, .uno:VerticalCaption, .uno:DrawText,
> .uno:VerticalText, .uno:Text_Marquee
I have those correctly disabled for read-only doc in my local build. Will push after bit more testing.
Comment 9 Commit Notification 2016-02-02 09:34:49 UTC
Maxim Monastirsky committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=11d605cc5a0c221d2423b6e63f502db660d085d2

tdf#84843 Stop using PseudoSlots for drawing slots

It will be available in 5.2.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.